package jp.agentec.sinaburocast.csv;

import org.seasar.s2csv.csv.annotation.column.CSVColumn;
import org.seasar.s2csv.csv.annotation.column.CSVMask;
import org.seasar.s2csv.csv.annotation.column.CSVRequired;
import org.seasar.s2csv.csv.annotation.entity.CSVEntity;

/**
 * PostalInfoCsv[郵便番号データ]にマッピングするCSVエンティティクラスです。
 *
 * @author arakawa
 */
@CSVEntity(header=false,demiliter=',',headerCheck=false,columnCountCheck=false)
public class PostalInfoCsv extends AbstractCsv {

	@CSVRequired
	@CSVMask(mask = "^[0-9]{5}$")
	@CSVColumn(columnIndex=0,columnName="全国地方公共団体コード")
	public String organizationCode;

	@CSVRequired
	@CSVColumn(columnIndex=1,columnName="旧郵便番号")
	public String oldPostalCode;

	@CSVRequired
	@CSVMask(mask = "^[0-9]{7}$")
	@CSVColumn(columnIndex=2,columnName="郵便番号")
	public String postalcode;

	@CSVRequired
	@CSVColumn(columnIndex=3,columnName="都道府県カナ名")
	public String prefectureKanaName;

	@CSVRequired
	@CSVColumn(columnIndex=4,columnName="市区町村カナ名")
	public String cityKanaName;

	@CSVRequired
	@CSVColumn(columnIndex=5,columnName="町域カナ名")
	public String areaKanaName;

	@CSVRequired
	@CSVColumn(columnIndex=6,columnName="都道府県名")
	public String prefecture;

	@CSVRequired
	@CSVColumn(columnIndex=7,columnName="市区町村名")
	public String city;

	@CSVRequired
	@CSVColumn(columnIndex=8,columnName="町域名")
	public String area;

	@CSVColumn(columnIndex=9,columnName="その他1")
	public String other1;

	@CSVColumn(columnIndex=10,columnName="その他2")
	public String other2;

	@CSVColumn(columnIndex=11,columnName="その他3")
	public String other3;

	@CSVColumn(columnIndex=12,columnName="その他4")
	public String other4;

	@CSVColumn(columnIndex=13,columnName="その他5")
	public String other5;

	@CSVColumn(columnIndex=14,columnName="その他6")
	public String other6;

	@CSVColumn(columnIndex=15,columnName="結果")
	public String okNg="OK";

	@CSVColumn(columnIndex=16,columnName="理由")
	public String reason="reason";

}
