package jp.agentec.sinaburocast.service;

import java.util.List;

import org.seasar.framework.container.annotation.tiger.Component;
import org.seasar.framework.container.annotation.tiger.InstanceType;

import jp.agentec.sinaburocast.entity.Config;

@Component(instance=InstanceType.SINGLETON)
public class ConfigService extends AbstractService<Config> {

	
	public static final String ID_SEQ_NAME = "config_id_seq";

	/**
	 * IDを発行して、登録する。
	 */
	public int insertConfig(Config config, String insId) {
		config.configId = getSeqNextVal(Integer.class, ID_SEQ_NAME);
		return super.insert(config, insId);
	}
	
    public Config findById(Integer configId) {
        return select().id(configId).getSingleResult();
    }
    public List<Config> findAllOrderById() {
        return select().orderBy("configId asc").getResultList();
    }
}